from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('ExtendedApplicationData')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereExtendedApplicationData");
  exportedObject.put("roleName", "WebSphereExtendedApplicationData");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.extendedapplicationdata.standalonemodulename", objid, "standaloneModuleName","ExtendedApplicationData");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.extendedapplicationdata.applicationname", objid, "applicationName","ExtendedApplicationData");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.extendedapplicationdata.logicalapplicationname", objid, "logicalApplicationName","ExtendedApplicationData");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('ExtendedApplicationData');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('ExtendedApplicationData')
  if not jsonobject.has("roleProperties"):
    raise Exception("ExtendedApplicationData resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "standaloneModuleName", roleProperties.optString("websphere.extendedapplicationdata.standalonemodulename", None));
  Util.addIfNotNone(properties, "applicationName", roleProperties.optString("websphere.extendedapplicationdata.applicationname", None));
  Util.addIfNotNone(properties, "logicalApplicationName", roleProperties.optString("websphere.extendedapplicationdata.logicalapplicationname", None));
  print "Creating ExtendedApplicationData with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("ExtendedApplicationData", parentid, properties);
  Util.popPathElement('ExtendedApplicationData');

def update(objid,jsonobject):
  Util.pushPathElement('ExtendedApplicationData')
  if not jsonobject.has("roleProperties"):
    raise Exception("ExtendedApplicationData resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.extendedapplicationdata.standalonemodulename", None), "standaloneModuleName","ExtendedApplicationData");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.extendedapplicationdata.applicationname", None), "applicationName","ExtendedApplicationData");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.extendedapplicationdata.logicalapplicationname", None), "logicalApplicationName","ExtendedApplicationData");
  if len(atts) != 0:
    print "Modifying ExtendedApplicationData with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "ExtendedApplicationData configuration up to date.";

  Util.popPathElement('ExtendedApplicationData');
